  MEMBER

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

    MAP
DoPrimeAutoInc PROCEDURE(SQLAN SELF, BYTE HandleErrors),BYTE,PRIVATE
    END

    INCLUDE('SQLAN.INC'),ONCE



SQLAN.PrimeAutoInc PROCEDURE
  CODE
    IF SELF.HasServerAutoInc
      RETURN SELF.DoPrimeAutoInc(1)
    ELSE
      RETURN PARENT.PrimeAutoInc()
    END

SQLAN.TryPrimeAutoInc PROCEDURE
  CODE
    IF SELF.HasServerAutoInc
      RETURN SELF.DoPrimeAutoInc(0)
    ELSE
      RETURN PARENT.TryPrimeAutoInc()
    END

SQLAN.DoPrimeAutoInc PROCEDURE(BYTE HandleErrors)
I SHORT,AUTO
  CODE
    IF SELF.UseFile() THEN RETURN Level:Fatal.
    If SELF.GetAutoIncDone() then Return Level:Benign.
!    IF SELF.Info.AutoIncDone  !no need to test hasAutoinc because if didnt this routine would not be called
!      RETURN Level:Benign
!    END
    ASSERT(NOT SELF.AutoIncField &= NULL)
    ADD(SELF.File)
    IF ERRORCODE()
      SELF.SetError(Msg:AddFailed)
      IF HandleErrors
        RETURN SELF.Throw()
      ELSE
        RETURN Level:Notify
      END
    ELSE
      IF SELF.TryGetAutoIncValue()
        SELF.SetError(Msg:AbortReading)
        IF HandleErrors
          RETURN SELF.Throw()
        ELSE
          RETURN Level:Notify
        END
      END
    END
    SELF.SetAutoIncDone(TRUE)
    RETURN Level:Benign

SQLAN.TryGetAutoIncValue PROCEDURE()
  CODE
    ASSERT(0)
    RETURN Level:Fatal

OMIT('***')

!Must Add to ABFILE.INC for SQLAN - SQL AutoNumbering
SetAutoIncDone  Procedure(BYTE pAutoIncDone)
GetAutoIncDone  Procedure(),BYTE

!Must add to ABFile.CLW At the end
FileManager.SetAutoIncDone Procedure(Byte pAutoIncDone)
  code
    SELF.INFO.AutoIncDone = pAutoIncDone
    PUT(SELF.INFO)
    ASSERT(~ERRORCODE())
    RETURN
FileManager.GetAutoIncDone Procedure()
  CODE
  RETURN(SELF.INFO.AUTOINCDONE)

***

